program ArsClip;







uses
  Forms,
  Windows,
  SysUtils,
  Dialogs,
  Math,
  System.Classes,
  UnitFrmDebug in 'UnitFrmDebug.pas' {FrmDebug},
  UnitFolderWriteTest in 'UnitFolderWriteTest.pas',
  UnitMisc in 'UnitMisc.pas',
  UnitFrmMainPopup in 'UnitFrmMainPopup.pas' {FrmMainPopup},
  UnitFrmConfig in 'UnitFrmConfig.pas' {FrmConfig},
  UnitFrmSysTrayMenu in 'UnitFrmSysTrayMenu.pas' {frmSysTrayMenu},
  UnitFrmClipboardManager in 'UnitFrmClipboardManager.pas' {frmClipboardManager},
  UnitListBoxMover in 'UnitListBoxMover.pas',
  UnitFrmPasteSelected in 'UnitFrmPasteSelected.pas' {FrmPasteSelected},
  UnitClipQueue in 'UnitClipQueue.pas',
  UnitFrmAbout in 'UnitFrmAbout.pas' {FrmAbout},
  UnitOtherQueue in 'UnitOtherQueue.pas',
  UnitFrmHotKey in 'UnitFrmHotKey.pas' {FrmHotkey},
  UnitKeyboardQuery in 'UnitKeyboardQuery.pas',
  UnitFrmChainWatcher in 'UnitFrmChainWatcher.pas' {FrmChainWatcher},
  UnitFrmPermanentNew in 'UnitFrmPermanentNew.pas' {FrmPermanent},
  UnitHotKey in 'UnitHotKey.pas',
  UnitPaste in 'UnitPaste.pas',
  UnitReportError in 'UnitReportError.pas' {FrmReportError},
  UnitToken in 'UnitToken.pas',
  UnitTWideChar in 'UnitTWideChar.pas',
  UnitFrmDummyUnicodeTooltip in 'UnitFrmDummyUnicodeTooltip.pas' {FrmDummyUnicodeTooltip},
  UnitSound in 'UnitSound.pas',
  UnitFrmEditItem in 'UnitFrmEditItem.pas' {FrmEditItem},
  UnitMenuItemTagdata in 'UnitMenuItemTagdata.pas',
  UnitSpecialPaths in 'UnitSpecialPaths.pas',
  UnitPopupGenerate in 'UnitPopupGenerate.pas',
  UnitFrmPermanentEdit in 'UnitFrmPermanentEdit.pas' {FrmPermanentEdit},
  UnitFrmDummyClipboardBar in 'UnitFrmDummyClipboardBar.pas' {frmClipboardBar},
  UnitFrmSearch in 'UnitFrmSearch.pas' {frmSearch},
  UnitFrmInstance in 'UnitFrmInstance.pas' {FrmDummyInstance},
  UnitCRC32 in 'UnitCRC32.PAS',
  UnitDestinationList in 'UnitDestinationList.pas',
  UnitTaskArray in 'UnitTaskArray.pas',
  UnitMiscCom in 'UnitMiscCom.pas',
  UnitFrmJumpList in 'UnitFrmJumpList.pas' {FrmJumpList},
  UnitFrmEditTextExternal in 'UnitFrmEditTextExternal.pas' {frmEditTextExternal},
  UnitFrmEditHistory in 'UnitFrmEditHistory.pas' {frmEditHistory},
  UnitIntegrity in 'UnitIntegrity.pas',
  UnitClipMenu in 'UnitClipMenu.pas' {FrameItemMenu: TFrame},
  UnitFramePopup in 'UnitFramePopup.pas' {ACPopup: TFrame},
  UnitACPopupClicks in 'UnitACPopupClicks.pas',
  UnitFrmFind in 'UnitFrmFind.pas' {frmFind},
  UnitFrmTooltipNew in 'UnitFrmTooltipNew.pas' {FrmTooltipNew},
  UnitFrmTriggerWindow in 'UnitFrmTriggerWindow.pas' {FrmTriggerWindow},
  UnitFrameMySlide in '..\MySlideTest2\UnitFrameMySlide.pas' {MySlide: TFrame},
  UnitFrmCheckForUpdate in '..\CheckForUpdate\UnitFrmCheckForUpdate.pas' {FrmCheckForUpdate},
  UnitDropFile in 'UnitDropFile.pas',
  UnitFrmSizeRichtext in 'UnitFrmSizeRichtext.pas' {frmSizeRichtext},
  UnitFrameClipDisplay in 'UnitFrameClipDisplay.pas' {FrameClipDisplay: TFrame},
  UnitHTMLConvert in 'UnitHTMLConvert.pas',
  UnitDragClip in 'UnitDragClip.pas',
  UnitFileCatch in 'UnitFileCatch.pas',
  UnitFrmDummyAlwaysOnTopFix in 'UnitFrmDummyAlwaysOnTopFix.pas' {FrmDummyAllwaysOnTopFix},
  UnitMyCursor in 'UnitMyCursor.pas',
  UnitDummyShellForm in 'UnitDummyShellForm.pas' {FrmDummyShellForm},
  UnitClipDatabase in 'UnitClipDatabase.pas',
  UnitFolderMonitor in 'UnitFolderMonitor.pas',
  UnitFrmImport in 'UnitFrmImport.pas' {FrmImport},
  UnitFramePermanentClips in 'UnitFramePermanentClips.pas' {FramePermanentClips: TFrame},
  UnitFrameImport in 'UnitFrameImport.pas' {FrameImport: TFrame},
  SQLite3Lib in 'SQLite3Lib.pas',
  SQLite3Classes in 'SQLite3Classes.pas',
  SQLite3Constants in 'SQLite3Constants.pas',
  UnitFrmDatabaseUpdate in 'UnitFrmDatabaseUpdate.pas' {frmDatabaseUpdate},
  UnitFrmShared in 'UnitFrmShared.pas' {frmShared},
  UnitThreadAttach in 'UnitThreadAttach.pas',
  UnitFocusManager in 'UnitFocusManager.pas',
  UnitJScript in 'UnitJScript.pas',
  UnitClipMenu2 in 'UnitClipMenu2.pas',
  UnitACPopupConfig in 'UnitACPopupConfig.pas',
  UnitACPopupPrototype in 'UnitACPopupPrototype.pas',
  UnitACPopupItem in 'UnitACPopupItem.pas',
  UnitClipboardGrabber in 'UnitClipboardGrabber.pas',
  UnitFrmRatTrap in 'UnitFrmRatTrap.pas' {FrmRatTrap},
  UnitOnlineScript in 'UnitOnlineScript.pas',
  UnitLoadClip in 'UnitLoadClip.pas',
  UnitFrmPreviewPopup in 'UnitFrmPreviewPopup.pas' {frmPreviewPopup},
  UnitFrameRichEdit in 'UnitFrameRichEdit.pas' {FrameRichEdit: TFrame},
  UnitFrameHTMLEdit in 'UnitFrameHTMLEdit.pas' {FrameHTMLEdit: TFrame},
  UnitMyClipboard in 'UnitMyClipboard.pas',
  UnitLoadHelper in 'UnitLoadHelper.pas',
  UnitRichTextUpdate in 'UnitRichTextUpdate.pas',
  UnitAutoBackup in '..\AutoBackup\UnitAutoBackup.pas',
  UnitFrmTextInspector in 'UnitFrmTextInspector.pas' {FrmTextInspector},
  UnitFrmTextInspectorControls in 'UnitFrmTextInspectorControls.pas' {frmTextInspectorControls},
  UnitViewExtract in 'UnitViewExtract.pas',
  UnitUIAutomation in 'UnitUIAutomation.pas',
  UnitTextInspectorData in 'UnitTextInspectorData.pas',
  UnitFrmTextContent in 'UnitFrmTextContent.pas' {frmTextContent},
  Unit64BitDetect in 'Unit64BitDetect.pas',
  UnitMouseScaler in 'UnitMouseScaler.pas',
  UnitEXCategoryPanel in 'UnitEXCategoryPanel.pas',
  UnitEXCategoryPanelGroup in 'UnitEXCategoryPanelGroup.pas',
  UnitClipMenuInfo in 'UnitClipMenuInfo.pas',
  UnitSetScreenCursor in 'UnitSetScreenCursor.pas',
  UnitExportClip in 'UnitExportClip.pas',
  UnitHtmlClip in 'UnitHtmlClip.pas',
  UnitLanuage in 'UnitLanuage.pas';

{$R *.res}
{$R icon.res}

var ci : TClipITem;
    par : string;

    DefaultParam : boolean;
    ExtractLanguage : boolean;
    HasLanguageFile : boolean;
  procedure MakeForm(ic : TComponentClass; var reference);
  var c, x : cardinal;
  begin
    c := Windows.GetTickCount;
    Application.CreateForm(ic, reference);
    if ExtractLanguage then begin
        TLanguage.ExtractFromForm(TForm(reference));
    end else if HasLanguageFile then begin
        TLanguage.LoadtoForm(TForm(reference));
    end;

    x := Windows.GetTickCount - c;
    if Assigned(FrmDebug) then begin
        frmDebug.AppendLog('[CREATE] ' + ic.ClassName + ' tick ' + IntToStr(x));
    end;
  end;
begin
    {$WARN UNIT_PLATFORM off}{$WARN SYMBOL_PLATFORM off}
    ReportMemoryLeaksOnShutdown := DebugHook <> 0;
    {$WARN UNIT_PLATFORM on}{$WARN SYMBOL_PLATFORM on}
    DefaultParam := false;

    HasLanguageFile := TLanguage.LanuageFileExists;

    par := '';
    if ParamCount in [1, 2] then begin
        par := lowercase(ParamStr(1));
    end;
    // -runclip "group\clipname"

    if SameText(par,'-popup') then begin
        //Application.OnException := FrmMainPopup.ApplicationException;
        FrmInstance_Init(INST_POPUP);
        Application.ProcessMessages;
    end else if SameText(par,'-second') then begin
        // a second instance does not get a FrmInstance messege window
    end else if SameText(par,'-runclip') then begin
        FrmInstance_Init(INST_RUNCLIP);
        Application.ProcessMessages;
    end else if SameText(par,'-language') then begin
        ExtractLanguage := true;
        TLanguage.DeleteLanguageFile;
    end else begin
        DefaultParam := true;
    end;
    if DefaultParam then begin
        FrmInstance_Init(INST_INIT);

        if not FrmInstance_IsFirst then  begin
            // detect Jump List data
            if par = '' then begin
                Frminstance_Init(INST_DEFAULT);
            end else begin
                FrmInstance_init(par);
            end;
            Application.ProcessMessages;
        end;
    end;


    // TODO : rethink if this is needed with the auto Data relocation in AC
    if (integrity.isHigh(Application.Handle)) and
        UnitMisc.isProgramFilesPath then begin
        ShowMessage('ArsClip: Running as Administrator in Program Files folder not allowed.');
        Application.Terminate;
    end;

    if not Application.Terminated then begin
        Application.Title := 'ArsClip';
        Application.Initialize;

        Application.MainFormOnTaskBar := true;    // while this seems backwards, it prevents a ghost taskbar window
        Application.ShowMainForm := false;

        TSharedMetadata.init;


        MakeForm(TFrmMainPopup, FrmMainPopup);
  MakeForm(TFrmDebug, FrmDebug);
  FrmDebug.AppendLog('Starting');
        //FrmDebug.AppendLog('TFrmMainpopup');

        MakeForm(TfrmDatabaseUpdate, frmDatabaseUpdate);
        MakeForm(TfrmShared, frmShared);
        MakeForm(TFrmRatTrap, FrmRatTrap);
        MakeForm(TfrmPreviewPopup, frmPreviewPopup);
        MakeForm(TfrmFind, frmFind);
        MakeForm(TFrmTextInspector, FrmTextInspector);
        MakeForm(TfrmTextInspectorControls, frmTextInspectorControls);
        MakeForm(TfrmTextContent, frmTextContent);
        if (frmMainPopup.Visible) then begin
            frmMainPopup.Hide;
        end;



        MakeForm(TFrmDummyShellForm, FrmDummyShellForm);
        MakeForm(TFrmImport, FrmImport);

        MakeForm(TFrmDummyAlwaysOnTopFix, FrmDummyAlwaysOnTopFix);



        FrmMainPopup.Visible := false;



        Application.OnException := FrmMainPopup.ApplicationException;
        TClipDatabase.preLoad;


        MakeForm(TFrmCheckForUpdate, FrmCheckForUpdate);
        MakeForm(TfrmSizeRichtext, frmSizeRichtext);

        MakeForm(TFrmDummyInstance, FrmDummyInstance);
        FrmDummyInstance.Visible := false;

        MakeForm(TFrmPermanent, FrmPermanent); // must appear before ClipboardBar
        MakeForm(TfrmClipboardBar, frmClipboardBar);
        MakeForm(TfrmSearch, frmSearch);
        MakeForm(TfrmEditHistory, frmEditHistory);
        MakeForm(TfrmPreviewPopup, frmPreviewPopup);
        MakeForm(TFrmAbout, FrmAbout);
        MakeForm(TfrmClipboardManager, frmClipboardManager);
        MakeForm(TFrmHotkey, FrmHotkey);

        MakeForm(TFrmPermanentEdit, FrmPermanentEdit);

        MakeForm(TFrmPasteSelected, FrmPasteSelected);
        MakeForm(TFrmEditItem, FrmEditItem);
        {Config must access other forms to set settings, making it last is safest}


        MakeForm(TFrmConfig, FrmConfig);
        if par = '-paste' then begin
            ci := TClipItem.Create;
            ci.GetClipboardItem(0);
            Paste.SendClip(ci);
            myfree(ci);
            Application.Terminate;
            EXIT;
        end;

        MakeForm(TfrmSysTrayMenu, frmSysTrayMenu);
        MakeForm(TFrmChainWatcher, FrmChainWatcher);
        MakeForm(TFrmReportError, FrmReportError);
        MakeForm(TFrmDummyUnicodeTooltip, FrmDummyUnicodeTooltip);
        MakeForm(TFrmJumpList, FrmJumpList);

        // prevent clipboard messages until after all forms are loaded
        TLoadHelper.reportLoaded;

        // a pinned icon activated jumplist when the program isn't running yet
        if (par <> '') and FrmJumpList.IsTaskArgument(par) then begin
            FrmJumpList.HandleTaskArgument(par);
        end;


        FrmDebug.AppendLog('Importing clips');
        TClipDatabase.importdata(frmDatabaseUpdate);


        // testing to make sure the clipboard is not changing when the temp list
        // may be altered
        frmClipboardManager.ActivateAfterLoad;
        FrmDebug.AppendLog('ClipboardManager - Activated');
        FrmMainPopup.ActivateAfterLoad;

        if FrmConfig.getCustomCursor then begin
            UnitMyCursor.CreateCustomCursor;
        end;

         // must be AFTER Config and ClipboardBar
        if frmconfig.ClipboardBarSetVisible then begin
            frmconfig.LoadClipboardBarState;
            frmClipboardBar.NewClipFound;
        end;

        frmSysTrayMenu.AfterLoadReport;
        if (FrmConfig.cbGlobalClipboard.Checked) then begin
            TGlobalClipboard.JoinInstancePool;
        end;

        FrmDebug.AppendLog('==Load Finished==');

        if (ExtractLanguage) then begin
            Application.Terminate;
        end;
    end else begin
        // TODO - add error reporting here
    end;




    ShowWindow(Application.Handle, SW_HIDE);
    Application.Run;
    FrmInstance_DeInit;


end.
